pipeline {
	agent any
	parameters {
		string(
			name: "REGISTRY_URL",
			defaultValue: "registry-itau.mastertech.com.br")
		string(
			name: "MYIMAGE",
			defaultValue: "registry-itau.mastertech.com.br/investimentos-img-richardson")
		string(
			name: "HOST_USER",
			defaultValue: "ubuntu")
		string(
			name: "HOST_IP",
			defaultValue: "18.188.80.202")
		string(
			name: "CONTAINER_NAME",
			defaultValue: "api_investimentos_richardson")
	}

	post {
		always {
			cleanWs()
		}
		failure {
			updateGitlabCommitStatus name: "build", 
			state: "failed"
		}
		success {
			updateGitlabCommitStatus name: "build",
			state: "success"
		}
	}
	options {
		gitLabConnection("gitlab")
	}	
	
	stages{	
		stage("Build"){
	    	when{branch "master"}
		    /*
		    Todos os blocos de stage (Package, Build and push image e Deploy serão executados apenas
	    	quando o evento disparado pelo SCM for na branch master.
		    */
		    stages{
				stage("Package") {
				    when{branch "master"}
				    steps {
				        script{
		        	    	sh "./mvnw package -DskipTests"
		       	 		}
		    		}
				}
				stage("Build and push image"){
				    steps{
				        script {
		        		    docker.withRegistry("https://${params.REGISTRY_URL}","registry_credential"){
				                def customImage=docker.build("${params.MYIMAGE}")
				                /* Os dois 'push' abaixo fazem o push da imagem para o registry com a tag latest e a tag do numero do build da pipeline */
		        		        customImage.push("${env.BUILD_ID}")
		                		customImage.push("latest")
		            		}
		        		}
		    		}
				}
				stage("Deploy"){
				    steps{
				        sh "ssh -o StrictHostKeyChecking=no -t ${params.HOST_USER}@${params.HOST_IP} 'docker pull ${params.MYIMAGE}:latest'"
				        sh "ssh -o StrictHostKeyChecking=no -t ${params.HOST_USER}@${params.HOST_IP} 'docker stop ${params.CONTAINER_NAME}'"
		        		sh "ssh -o StrictHostKeyChecking=no -t ${params.HOST_USER}@${params.HOST_IP} 'docker run --rm -p 5000:8080 -d --name ${params.CONTAINER_NAME} ${params.MYIMAGE}:latest'"
		    		}
				}
	    	}
		}
	}
}

